// Funciona

nslImport nslAllImports;

nslModule BumpAvoid (int tectsize) 
{
	public NslDinFloat0 depthY();
	public NslDinFloat0 depthX();
	public NslDoutFloat1 baf(tectsize);			
	public NslDinFloat1 gaps(tectsize);
	public NslDoutFloat1 gapsf(tectsize);
	//public NslDoutFloat0 ps();
	public NslDouble0 ps();
	public NslDinFloat0 psta();
	private NslFloat0 field_A();
	private NslFloat0 field_center();
	private NslFloat0 tune_tm();	// TUNE GAPS field (avoid bumping).
	private NslFloat0 tune_tm_base();
	private NslFloat1 tune_tm_layer(tectsize);
	private NslFloat0 safeDistance();
	private NslFloat0 rsta();
	private NslFloat0 th();

	public void initSys()
	{
		rsta = 1.0;	// Tactile & Bumping Avoid
		ps = 0;
	}

	public void simRun()
	{
		// both should be larger than zero for no bump
		if (depthY <= safeDistance && depthX <= safeDistance) 	//Bumping.   
			ps = 0;
		else
			ps = -1.0;		// Go down fast: -2.0

		if (tune_tm < 1.5)		// saturate tune_tm.
			tune_tm = tune_tm + tune_tm_base;

		tune_tm_layer = tune_tm;
		tune_tm_layer = tune_tm_layer ^ nslStep(-gaps);	// Modulate only already active neurons.

		gaps = gaps - tune_tm_layer; // gaps fields gets tuned.
		gapsf = gaps;

		ps = ps + rsta*psta;
   		//ps = nslSigma(ps,-1.0,1.0,-1.0,1.0);	
   		ps = NslSigmoid.eval(ps,-1.0,1.0,-1.0,1.0);

		// every bump it increases tune_tm until it reaches a saturation point.
		if (ps > th)
		{
			field_center = field_center +.3;	// Tunes baf by increasing eccentricity.
			baf[field_center.getint()] = field_A; // Generate Bumping Avoidance FIELD.
		}
		else
			baf = 0;
	}
}
